import { Component, OnInit } from '@angular/core';
import { ToastrService } from 'ngx-toastr';
import { AlertService } from 'src/app/services/alert.service';
import { Formcservice} from './Formc.service';
import { AbstractControl, FormArray, FormBuilder, FormGroup, Validators, ValidationErrors } from '@angular/forms';
import { ExtensionService } from 'src/app/services/fnd/extension.service';
import { DashboardContentModel2 } from 'src/app/models/builder/dashboard'; 
import { Formccardvariable } from './Formc_cardvariable';
import { UserInfoService } from 'src/app/services/user-info.service';
declare var JsBarcode: any; 
@Component({
  selector: 'app-Formc',
  templateUrl: './Formc.component.html',
  styleUrls: ['./Formc.component.scss']
})
export class FormcComponent implements OnInit {
  cardButton = Formccardvariable.cardButton;
  cardmodeldata = Formccardvariable.cardmodeldata;
  public dashboardArray: DashboardContentModel2[];
  isCardview = Formccardvariable.cardButton;
  cardmodal;  changeView(){
  this.isCardview = !this.isCardview;
  }
    beforeText(fieldtext: string): string { // Extract the text before the first '<'
    const index = fieldtext.indexOf('<');
    return index !== -1 ? fieldtext.substring(0, index) : fieldtext;
  }
  afterText(fieldtext: string): string { // Extract the text after the last '>'
    const index = fieldtext.lastIndexOf('>');
    return index !== -1 ? fieldtext.substring(index + 1) : '';
  }
  transform(fieldtext: string): string {
    const match = fieldtext.match(/<([^>]*)>/);
    return match ? match[1] : ''; // Extract the text between '<' and '>'
  }
 userrole;
  rowSelected :any= {};
  modaldelete=false;
  modalEdit=false;
  modalAdd= false;
  public entryForm: FormGroup;
  loading = false;
  product;
  modalOpenedforNewLine = false;
  newLine:any;
 additionalFieldsFromBackend: any[] = [];
  formcode = 'Formc_formCode'
tableName = 'Formc';  checkFormCode; selected: any[] = []; constructor(
    private extensionService: ExtensionService,
private userInfoService:UserInfoService,
    private mainService:Formcservice,
    private alertService: AlertService,
    private toastr: ToastrService,
    private _fb: FormBuilder,
  ) { }
// component button 
  ngOnInit(): void {
    if(this.cardmodeldata !== ''){
     this.cardmodal = JSON.parse(this.cardmodeldata);
    this.dashboardArray = this.cardmodal.dashboard.slice();
    console.log(this.dashboardArray)
    }
    this.userrole=this.userInfoService.getRoles();
    this.getData();
    this.entryForm = this._fb.group({
currencys : [null, { updateOn: 'blur' }],



qrcode : [null],

barcode : [null],

numbers : [null,[Validators.required]],

numbered : [null,[Validators.required]],



child: this.initLinesForm(),

 
 
a:[null],
 

 
b:[null],
 


 


 



















  }); // component_button200
 // form code start
    this.extensionService.getJsonObjectsByFormCodeList(this.formcode).subscribe(data => {
      console.log(data);
      const jsonArray = data.map((str) => JSON.parse(str));
      this.additionalFieldsFromBackend = jsonArray;
      this.checkFormCode = this.additionalFieldsFromBackend.some(field => field.formCode === "Formc_formCode");
      console.log(this.checkFormCode);
      console.log(this.additionalFieldsFromBackend);
      if (this.additionalFieldsFromBackend && this.additionalFieldsFromBackend.length > 0) {
        this.additionalFieldsFromBackend.forEach(field => {
          if (field.formCode === this.formcode) {
            if (!this.entryForm.contains(field.extValue)) {
              // Add the control only if it doesn't exist in the form
              this.entryForm.addControl(field.extValue, this._fb.control(field.fieldValue));
            }
          }
        });
      }
    });
    console.log(this.entryForm.value);
    // form code end 





















  }















initLinesForm() {   return this._fb.group({

 
  namem: [null],
 
		

});   } 
		





 error; 
  getData() {
    this.mainService.getAll().subscribe((data) => {
      console.log(data);
      this.product = data;
 if(this.product.length==0){
        this.error="No Data Available"
     }   
    },(error) => {
      console.log(error);
      if(error){
       this.error="Server Error";
     }
    });
  }
  onEdit(row) {
    this.rowSelected = row;






  //    bar code field start 
   setTimeout(function(){ 
		JsBarcode("#barcodebarcode", row?.barcode);
	     }, 500);
	   //    bar code field start





//calculated field start
	
 
	   this. numbers= row.numbers;
	  

 
	   this. numbered= row.numbered;
	  

//calculated field end








    this.modalEdit = true;
  }
   onDelete(row) {
    this.rowSelected = row;
     this.modaldelete=true;
  }
  delete(id)
  {
    this.modaldelete = false;
    console.log("in delete  "+id);
    this.mainService.delete(id).subscribe(
      (data) => {
        console.log(data);
        this.ngOnInit();
  if (data) {				      this.toastr.success('Deleted successfully');      }
    });
  }
    onUpdate(id) {
    this.modalEdit = false;












//calculated field start
	
 
this.rowSelected. numbers= this. numbers;
	 

 
this.rowSelected. numbered= this. numbered;
	 

this.onInputChangecalculatedadd ();
 //calculated field end







    //console.log("in update");
    console.log("id  " + id);
    console.log(this.rowSelected);
    //console.log("out update");
    this.mainService.update(id, this.rowSelected).subscribe(
      (data) => {
        console.log(data);
        if (data || data.status >= 200 && data.status <= 299) {
          this.toastr.success("Update Successfully");
        }





















      }, (error) => {
        console.log(error);
        if (error.status >= 200 && error.status <= 299) {
          // this.toastr.success("update Succesfully");
        }
        if (error.status >= 400 && error.status <= 499) {
          this.toastr.error("Not Updated");
        }
        if (error.status >= 500 && error.status <= 599) {
          this.toastr.error("Not Updated");
        }
      });
    setTimeout(() => {
      this.ngOnInit();
    }, 500);
  } 
onCreate() {
     this.modalAdd=false;












//calculated field start
	
 
this.entryForm.value. numbers  = this.numbers ;
	  

 
this.entryForm.value. numbered  = this.numbered ;
	  

//calculated field end







  this.mainService.create(this.entryForm.value).subscribe(
    (data) => {
      console.log(data);
  if (data || data.status >= 200 && data.status <= 299) {
          this.toastr.success("Added Successfully");
        }





















      }, (error) => {
        console.log(error);
        if (error.status >= 200 && error.status <= 299) {
          // this.toastr.success("Added Succesfully");
        }
        if (error.status >= 400 && error.status <= 499) {
          this.toastr.error("Not Added");
        }
        if (error.status >= 500 && error.status <= 599) {
          this.toastr.error("Not Added");
        }
      });
    setTimeout(() => {
      this.ngOnInit();
    }, 500);
  }
  goToAdd(row) {
this.modalAdd = true; this.submitted = false;











  //calculated field start

  
 
  this. numbers  = '';
 

 
  this. numbered  = '';
 



  this.total = '';

  //calculated field end





 this.getdataggData();


  }
 submitted = false;
onSubmit() {
  console.log(this.entryForm.value);
 this.submitted = true;
  if (this.entryForm.invalid) {
    return;
  }this.onCreate();

} 
//currency  field start
   formatCurrencycurrencys () {
    // Format the currency with two decimal places    
	this.rowSelected.currencys = Number(this.rowSelected.currencys ).toFixed(2);
    // Remove commas from the formatted currency   
	 this.rowSelected.currencys = this.rowSelected.currencys?.replace(/,/g, '');  }
  //currency  field end

//Value List field start    
valuelistMode;
searchcusttextvaluey :any;    
 valueListModalvaluey :boolean=false;
    openvalueListvaluey(mode){
 this.valueListModalvaluey=!this.valueListModalvaluey ; 
      this.valuelistMode = mode;     }
     customerdatavaluey ;     
cutomererror;
   clickedID:number;

getcustvalueyID(id:number){    
 this.clickedID=id;
						    console.log("clicked by id"+ id);
						    this.mainService.getById(id).subscribe((data) => {       console.log(data);
						         if(this.valuelistMode == "ADD"){ 

							
 
							this.entryForm.get('numbers').setValue(data.numbers);
							 


						}else if(this.valuelistMode == "EDIT"){

							
 
							this.rowSelected.numbers= data. numbers
							 


						}       });       this.valueListModalvaluey =false;
						    }    //value List field end 



//bar code field start 
     generateBarcodebarcode(value) {
      const barcodeValue = value;
      const barcodeElement = document.getElementById("barcodebarcode"); 
      if (barcodeElement) {         if (barcodeValue) {
          JsBarcode(barcodeElement, barcodeValue, {             format: "CODE128"
          });         } else {
          // Clear the barcode if the input is empty
          barcodeElement.innerHTML = '';         }       }     }
         //    bar code field end 





 // calculated field code start 

 
 numbers; 
  

 
 numbered; 
  

  total ; 
 calculateOperators = "Addition"
onInputChangecalculatedadd() {
const lastObj = 0
const lastObjstring = ''
	
 

    const numbers= this.numbers|| '';

	const numbersValue = parseFloat(this.numbers) || 0;

	  

 

    const numbered= this.numbered|| '';

	const numberedValue = parseFloat(this.numbered) || 0;

	  

if (this.calculateOperators =="Addition") {
 this.total = (   
	
 
		 numbersValue +
	 

 
		 numberedValue +
	 
 lastObj).toString();
}
if (this.calculateOperators == "Subtraction") {
	 this.total = (   

 
 numbersValue   -
	 

 
 numberedValue   -
	 

	lastObj).toString();
}
if (this.calculateOperators =="Multiplication") {
  this.total = (

	
 
	numbersValue *
		 

 
	numberedValue *
		 

lastObj).toString();
}
if (this.calculateOperators =="Division") {
 
	this.total = ( 

 
numbersValue   /
	 

 
numberedValue   /
	 

lastObj).toString();

}
if (this.calculateOperators =="Concatination") {
 this.total =  

 
numbers+ ' '+
	 

 
numbered+ ' '+
	 
 lastObjstring 
}
}





//datagrid datagg  filed start    
productdatagg;     
 rowsdatagg :any[];
         getHeadersdatagg () {          
			 this.rowsdatagg = this.productdatagg;         
  let headers: string[] = [];
          if(this.rowsdatagg ) {             
this.rowsdatagg.forEach((value) => {         
      Object.keys(value).forEach((key) => {
                if(!headers.find((header) => header == key)){
                  headers.push(key)             
    }         
              })                 
     })         
}
         
 return headers;      
   } 
 //datagrid datagg filed end 
					    
getdataggData() {
    this.mainService.getdataggAll().subscribe((data) => {
      console.log(data);      this.productdatagg  = data; 
    });
}

// updateaction
}



















